uses crt, dos, mn_abstr, mn_polje, mn_kurz, mn_kazal;

const
  maxMn=9; {stevilo mnozic v delu za interaktivno delo - 1}
  razmik=2; {razmik med stevilkami mnozic (povecaj, ce nastopijo dvomestna stevila)}
  minY=7; {prva vrsta dela z operacijami z mnozicami}
  maxY=13; {zadnja vrsta dela z operacijami z mnozicami}
  maxSt=20; {stevilo elementov v mnozici v delu za merjenje casa}

type
  kVsTest=^vsTest;
  vsTest=object (vsebina) {glej mn_abstr; tu objekt razsirjen za namene tega programa}
    st: integer; {vsebina elementa mnozice}
    procedure izpis; {izpise st}
    function jeEnak (vs: kVsebina): boolean; virtual;
    function prepisi: kVsebina; virtual;
  end;
  kMnPoljeTest=^mnPoljeTest;
  mnPoljeTest=object (mnPolje) {glej mn_polje; tu objekt razsirjen za namene tega programa}
    procedure izpis; {izpise vse elemente}
  end;
  kMnKurzorjiTest=^mnKurzorjiTest;
  mnKurzorjiTest=object (mnKurzorji) {glej mn_kurz}
    procedure izpis;
  end;
  kMnKazalciTest=^mnKazalciTest;
  mnKazalciTest=object (mnKazalci) {glej mn_kazal}
    procedure izpis;
  end;
  kElTipZap=^elTipZap;
  elTipZap=record {element linearnega seznama, v katerem je zapisano tipicno zaporedje operacij v delu za merjenje casa}
    operacija: (kreiranje, dodajanje, brisanje, pripadnost, unija, presek); {vrsta operacija}
    vrednost: integer; {stevilo, za katero se operacija izvede}
    naslednji: kElTipZap; {kazalec na nasednji element}
  end;

procedure vsTest.izpis;
begin
  write (st, ' ');
end;

function vsTest.jeEnak (vs: kVsebina): boolean;
begin
  if st=kVsTest (vs)^.st then jeEnak:=true else jeEnak:=false;
end;

function vsTest.prepisi: kVsebina;
  var zac: kVsebina;
begin
  zac:=new (kVsTest, vsKons);
  kVsTest (zac)^.st:=st;
  prepisi:=zac;
end;

procedure mnPoljeTest.izpis;
var n: integer;
begin
  for n:=0 to zadnji do kVsTest (polje [n])^.izpis;
end;

procedure mnKurzorjiTest.izpis;
  var trenutni: integer;
begin
  trenutni:=polje [0].naslednji;
  while trenutni<>polje [zadnji].naslednji do begin
    kVsTest (polje [trenutni].vsebina)^.izpis;
    trenutni:=polje [trenutni].naslednji;
  end;
end;

procedure mnKazalciTest.izpis;
  var trenutni: kElKazalci;
begin
  trenutni:=prvi^.naslednji;
  while trenutni<>nil do begin
    kVsTest (trenutni^.vsebina)^.izpis;
    trenutni:=trenutni^.naslednji;
  end;
end;

var
  stanje: (zacInterakt, zacMerjenje, vmesInterakt, vmesMerjenje, konec); {stanje, v katerem je program: zacetek interaktivnega
                                                                         dela, interaktivno delo, zacetek merjenja casa,
                                                                         merjenje casa, izhod}
  testneMn: array [0..maxMn] of kMnozica; {polje mnozic, s katerimi se dela v delu za interaktivno delo}
  polozaj: record {polozaj rdecega pravokotnika}
    x, y: integer;
  end;
  znak: char; {pritisnjena tipka}
  iter: boolean; {iterativnost/rekurzivnost operacij v delu za interaktivno delo}
  n1, n2: integer;
  ponoviPO, ponoviTZ, {stevilo ponovitev posameznih operacij in operacij v tipicnem zaporedju v delu za merjenje casa}
    verKreir, verDodaj, verBris, verPripad, verUnija, verPresek: longInt; {verjetnosti za posamezne operacije v tipicnem
                                                                          zaporedju v delu za merjenje casa}

procedure okno (noter: boolean); {ce noter=true, gre v okno za vpisovanje vrednosti in izpis v delu za interaktivno delo, ->}
begin                            {sicer pa gre ven iz njega}
  if noter then begin
    window (2, 17, 79, 24);
    textBackground (black);
    textColor (yellow);
    clrscr;
  end else window (1, 1, 80, 25);
end;

procedure okence (x, y, s: integer; var vred: longInt; beri: boolean); {gre v okence na polozaj x, y sirine s; ce beri=true ->}
begin                                                                  {prebere vrednost vred, sicer pa jo samo izpise}
  window (x, y, x+s, y);
  textBackground (black);
  textColor (yellow);
  clrscr;
  if beri then readln (vred);
  write (vred);
  window (1, 1, 80, 25);
  textBackground (cyan);
  textColor (black);
end;

function cas: longInt; {vrne cas v stotinkah sekunde}
  var
    ure, min, sek, sto: word;
    skupaj: longInt;
begin
  getTime (ure, min, sek, sto);
  cas:=longInt (ure)*360000+longInt (min)*6000+longInt (sek)*100+longInt (sto);
end;

procedure pZacInterakt; {zacetek dela za iteraktivno delo}
begin
  polozaj.x:=0; {nastavitev zacetnih vrednosti spremenljivk}
  polozaj.y:=minY-2;
  iter:=true;
  textBackground (cyan); {izpis stvari, ki se med delom ne spreminjajo}
  textColor (black);
  clrScr;
  write (' Program za delo z mnozicami, napisal Mitja Lustrek');
  gotoXY (1, minY);
  writeln (' Naredi');
  writeln (' Dodaj element');
  writeln (' Brisi element');
  writeln (' Preveri pripadnost');
  writeln (' Unija');
  writeln (' Presek');
  write (' Izpis');
  gotoXY (1, 5);
  textColor (magenta);
  write (' polje');
  textColor (blue);
  write ('  kazalci');
  textColor (brown);
  write ('  kurzorji');
  okno (true);
  okno (false);
end;

procedure pVmesInterakt; {del za interaktivno delo}
  var vsTestZac: kVsTest;
begin
  case znak of
    'K': if polozaj.x>0 then dec (polozaj.x); {premikanje po izbirah}
    'M': inc (polozaj.x);
    'H': if polozaj.y>minY-2 then dec (polozaj.y);
    'P': if polozaj.y<maxY+1 then inc (polozaj.y);
    #13: case polozaj.y of {pritisk na enter}
      minY-2: if polozaj.x=1 then stanje:=zacMerjenje; {preklop na del za merjenje casa}
      minY-1: if polozaj.x=0 then iter:=true else iter:=false; {preklapljanje med rekurzijo in iteracijo}
      minY: begin {kreiranje mnozice}
        okno (true);
        writeln ('1 - polje');
        writeln ('2 - kazalci');
        writeln ('3 - kurzorji');
        write ('Izberi: ');
        readln (n1);
        clrscr;
        okno (false);
        case n1 of
          1: begin
            if testneMn [polozaj.x]=nil then testneMn [polozaj.x]:=new (kMnPoljeTest, mnKons) else {ce je mnozica nil, se
                                                                                                   rezervira prostor v spominu}
              if testneMn [polozaj.x]^.tip<>poljeEl then begin {ce je drugega tipa, se prostor v spominu sprosti, nato pa ->}
                dispose (testneMn [polozaj.x], mnDest);        {rezervira za pravi tip}
                testneMn [polozaj.x]:=new (kMnPoljeTest, mnKons);
              end else testneMn [polozaj.x]^.mnDest; {ce je pravega tipa, se sprosti prostor v spominu samo sprosti}
            testneMn [polozaj.x]^.naredi; {inicializacija}
          end;
          2: begin
            if testneMn [polozaj.x]=nil then testneMn [polozaj.x]:=new (kMnKazalciTest, mnKons) else
              if testneMn [polozaj.x]^.tip<>kazalci then begin
                dispose (testneMn [polozaj.x], mnDest);
                testneMn [polozaj.x]:=new (kMnKazalciTest, mnKons);
              end else testneMn [polozaj.x]^.mnDest;
            testneMn [polozaj.x]^.naredi;
          end;
          3: begin
            if testneMn [polozaj.x]=nil then testneMn [polozaj.x]:=new (kMnKurzorjiTest, mnKons) else
              if testneMn [polozaj.x]^.tip<>kurzorji then begin
                dispose (testneMn [polozaj.x], mnDest);
                testneMn [polozaj.x]:=new (kMnKurzorjiTest, mnKons);
              end else testneMn [polozaj.x]^.mnDest;
            testneMn [polozaj.x]^.naredi;
          end;
        end;
      end;
      minY+1: {dodajanje elementa}
        if testneMn [polozaj.x]<>nil then begin
          okno (true);
          write ('Vpisi stevilo: ');
          readln (n1);
          clrscr;
          vsTestZac:=new (kVsTest, vsKons);
          vsTestZac^.st:=n1; {vsTestZac postane novi element}
          if testneMn [polozaj.x]^.dodaj (vsTestZac, true, iter) then write ('Dodan.') else begin {poizkusi se dodati}
            dispose (vsTestZac, vsDest); {ce ne uspe, se zbrise}
            write ('Je ze v mnozici ali pa je mnozica polna.');
          end;
          okno (false);
        end;
      minY+2: {brisanje elementa}
        if testneMn [polozaj.x]<>nil then begin
          okno (true);
          write ('Vpisi stevilo: ');
          readln (n1);
          clrscr;
          vsTestZac:=new (kVsTest, vsKons);
          vsTestZac^.st:=n1; {vsTestZac je element, kateremu enak se zbrise}
          if testneMn [polozaj.x]^.brisi (vsTestZac) then write ('Zbrisan.') else write ('Ga ni v mnozici.');
          dispose (vsTestZac, vsDest);
          okno (false);
        end;
      minY+3: {preverjanje pripadnosti}
        if testneMn [polozaj.x]<>nil then begin
          okno (true);
          write ('Vpisi stevilo: ');
          readln (n1);
          clrscr;
          vsTestZac:=new (kVsTest, vsKons); {vsTestZac je element, kateremu enak se isce}
          vsTestZac^.st:=n1;
          if testneMn [polozaj.x]^.pripada (vsTestZac, iter) then write ('Je v mnozici.') else write ('Ga ni v mnozici.');
          dispose (vsTestZac, vsDest);
          okno (false);
        end;
      minY+4: {unija}
        if testneMn [polozaj.x]<>nil then begin
          okno (true);
          write ('1. mnozica: ');
          readln (n1);
          write ('2. mnozica: ');
          readln (n2);
          clrscr;
          if testneMn [polozaj.x]^.unija (testneMn [n1], testneMn [n2], iter) then write ('Unija narejena.')
            else write ('Ena izmed mnozic ne obstaja.');
          okno (false);
        end;
      minY+5: {presek}
        if testneMn [polozaj.x]<>nil then begin
          okno (true);
          write ('1. mnozica: ');
          readln (n1);
          write ('2. mnozica: ');
          readln (n2);
          clrscr;
          if testneMn [polozaj.x]^.presek (testneMn [n1], testneMn [n2], iter) then write ('Presek je narejen.')
            else write ('Ena izmed mnozic ne obstaja.');
          okno (false);
        end;
      minY+6: {izpis}
        if testneMn [polozaj.x]<>nil then begin
          okno (true);
          case testneMn [polozaj.x]^.tip of {upostevati je treba tip mnozice, ker je izpis dodan sele v vmesniku}
            poljeEl: kMnPoljeTest (testneMn [polozaj.x])^.izpis;
            kurzorji: kMnKurzorjiTest (testneMn [polozaj.x])^.izpis;
            kazalci: kMnKazalciTest (testneMn [polozaj.x])^.izpis;
          end;
          okno (false);
        end;
      maxY+1: stanje:=konec; {izhod}
    end;
  end;
  if (polozaj.y>=minY) and (polozaj.x>maxMn) then polozaj.x:=maxMn; {prilagajanje vodoravnega polozaja glede na stevilo ->}
  if (polozaj.y<minY) and (polozaj.x>1) then polozaj.x:=1;          {izbir v vrsti}
  for n1:=minY to maxY do {izpis stevilk mnozic}
    for n2:=0 to maxMn do begin
      if (polozaj.x=n2) and (polozaj.y=n1) then textBackground (red) else textBackground (cyan);
      if testneMn [n2]<>nil then begin
        case testneMn [n2]^.tip of
          poljeEl: textColor (magenta);
          kurzorji: textColor (brown);
          kazalci: textColor (blue);
        end;
      end else textColor (black);
      gotoXY (21+2*n2, n1);
      write (n2);
    end;
  if (polozaj.y=minY-2) and (polozaj.x=0) then textBackground (red) else textBackground (cyan); {izpis ostalih izbir}
  textColor (yellow);
  gotoXY (2, 3);
  write ('Interaktivno delo');
  if (polozaj.y=minY-2) and (polozaj.x=1) then textBackground (red) else textBackground (cyan);
  textColor (black);
  gotoXY (21, 3);
  write ('Merjenje casa');
  if (polozaj.y=minY-1) and (polozaj.x=0) then textBackground (red) else textBackground (cyan);
  if iter then textColor (yellow) else textColor (black);
  gotoXY (2, 4);
  write ('Iterativno');
  if (polozaj.y=minY-1) and (polozaj.x=1) then textBackground (red) else textBackground (cyan);
  if not iter then textColor (yellow) else textColor (black);
  gotoXY (14, 4);
  write ('Rekurzivno');
  if polozaj.y=maxY+1 then textBackground (red) else textBackground (cyan);
  textColor (black);
  gotoXY (2, 15);
  write ('Izhod');
end;

procedure pZacMerjenje (naZacetku: boolean); {zacetek dela za merjenje casa}
begin
  if naZacetku then begin {ce naZacetku=true, se polozaj nastavi na stevilo ponivitev posameznih operacij}
    polozaj.x:=1;
    polozaj.y:=0;
  end;
  textBackground (cyan); {izpis stvari, ki se med delom ne spreminjajo}
  textColor (black);
  clrScr;
  write (' Program za delo z mnozicami, napisal Mitja Lustrek');
  gotoXY (1, 7);
  writeln (' Ŀ');
  writeln ('                          iteracija                 rekurzija         ');
  writeln (' Ĵ');
  writeln (' operacija        polje   kazalci kurzorjipolje   kazalci kurzorji');
  writeln (' Ĵ');
  writeln (' kreiranje                                                        ');
  writeln (' Ĵ');
  writeln (' dodajanje                                                        ');
  writeln (' Ĵ');
  writeln (' brisanje                                                         ');
  writeln (' Ĵ');
  writeln (' pripadnost                                                       ');
  writeln (' Ĵ');
  writeln (' unija                                                            ');
  writeln (' Ĵ');
  writeln (' presek                                                           ');
  writeln (' Ĵ');
  writeln (' tipicno zaporedje                                                ');
    write (' ');
  okence (32, 4, 7, ponoviPO, false);
  okence (62, 4, 7, ponoviTZ, false);
  okence (12, 5, 2, verKreir, false);
  okence (26, 5, 2, verDodaj, false);
  okence (39, 5, 2, verBris, false);
  okence (54, 5, 2, verPripad, false);
  okence (64, 5, 2, verUnija, false);
  okence (75, 5, 2, verPresek, false);
  okno (false);
  gotoXY (2, 4);
  write ('Ponovitve');
end;

procedure pVmesMerjenje; {del za merjenje casa}
  var
    n, cas1, cas2, ponovi: longInt; {cas1, cas2 - cas ob zacetku in koncu merjenja; ponovi - stevilo ponovitev operacije}
    tip, operacija, nakljucje: integer; {tip - polje/kazalci/kurzorji, operacija - operacija nad mnozico}
    mn1, mn2, mn3, mnTZ1, mnTZ2, mnTZ3: kMnozica; {mnozice za testiranje posameznih operacij, tipicnega zaporedja}
    zacSproti, zacEnkrat: kVsebina; {zacSproti - zacasni element mnozice, za katerega je potrebno vsakic posebej rezervirati
                                    spomin; zacEnkrat - tak, za katerega se spomin rezervira samo na zacetku}
    iterMeri: boolean; {iterativnost/rekurzivnost}
    prviTZ, trenutni: kElTipZap; {prviTZ - zacetek linearnega seznama z operacijami in stevili v tipicnem zaporedju}
begin
  case znak of
    'K': if polozaj.x>0 then dec (polozaj.x); {premikanje po izbirah}
    'M': inc (polozaj.x);
    'H': if polozaj.y>0 then dec (polozaj.y);
    'P': if polozaj.y<2 then inc (polozaj.y);
    #13: case polozaj.y of {pritisk na enter}
      0: case polozaj.x of
        0: stanje:=zacInterakt; {preklop na del za interaktivno delo}
        2: begin {izvedba merjanja}
          znak:=#0;
          pZacMerjenje (false); {osvezitev zaslona}
          pVmesMerjenje;
          prviTZ:=new (kElTipZap);
          randomize;
          trenutni:=prviTZ;
          for n:=1 to ponoviTZ do begin {doloci se tipicno zaporedje}
            trenutni^.naslednji:=new (kElTipZap);
            trenutni^.naslednji^.vrednost:=random (maxSt);
            nakljucje:=random (verKreir+verDodaj+verBris+verPripad+verUnija+verPresek);
            if nakljucje<verKreir then trenutni^.naslednji^.operacija:=kreiranje;
            if (nakljucje>=verKreir) and (nakljucje<verKreir+verDodaj) then trenutni^.naslednji^.operacija:=dodajanje;
            if (nakljucje>=verKreir+verDodaj) and (nakljucje<verKreir+verDodaj+verBris) then
              trenutni^.naslednji^.operacija:=brisanje;
            if (nakljucje>=verKreir+verDodaj+verBris) and (nakljucje<verKreir+verDodaj+verBris+verPripad) then
              trenutni^.naslednji^.operacija:=pripadnost;
            if (nakljucje>=verKreir+verDodaj+verBris+verPripad) and (nakljucje<verKreir+verDodaj+verBris+verPripad+verUnija)
              then trenutni^.naslednji^.operacija:=unija;
            if (nakljucje>=verKreir+verDodaj+verBris+verPripad+verUnija) then trenutni^.naslednji^.operacija:=presek;
            trenutni:=trenutni^.naslednji;
            trenutni^.naslednji:=nil;
          end;
          zacEnkrat:=new (kVsTest, vsKons);
          for tip:=0 to 2 do begin {tipi: 0 -polje, 1 - kazalci, 2 - kurzorji}
            case tip of {rezervira se spomin za ustrezen tip mnozice}
              0: begin
                mn1:=new (kMnPolje, mnKons);
                mn2:=new (kMnPolje, mnKons);
                mn3:=new (kMnPolje, mnKons);
                mnTZ1:=new (kMnPolje, mnKons);
                mnTZ2:=new (kMnPolje, mnKons);
                mnTZ3:=new (kMnPolje, mnKons);
              end;
              1: begin
                mn1:=new (kMnKazalci, mnKons);
                mn2:=new (kMnKazalci, mnKons);
                mn3:=new (kMnKazalci, mnKons);
                mnTZ1:=new (kMnKazalci, mnKons);
                mnTZ2:=new (kMnKazalci, mnKons);
                mnTZ3:=new (kMnKazalci, mnKons);
              end;
              2: begin
                mn1:=new (kMnKurzorji, mnKons);
                mn2:=new (kMnKurzorji, mnKons);
                mn3:=new (kMnKurzorji, mnKons);
                mnTZ1:=new (kMnKurzorji, mnKons);
                mnTZ2:=new (kMnKurzorji, mnKons);
                mnTZ3:=new (kMnKurzorji, mnKons);
              end;
            end;
            mn1^.naredi; {mnozice se inicializirajo}
            mn2^.naredi;
            mn3^.naredi;
            mnTZ1^.naredi;
            mnTZ2^.naredi;
            mnTZ3^.naredi;
            for operacija:=0 to 6 do begin {operacije: 0 - kreiranje, 1 - dodajanje, 2 - brisanje, 3 - preverjanje pripadnosti,
                                           4 - unija, 5 - presek, 6 - tipicno zaporedje}
              iterMeri:=true; {v prvi izvedbi zanke while so operacije iterativne}
              repeat
                trenutni:=prviTZ^.naslednji; {trenutni gre na zacetek linearnega seznama za tipicno zaporedje}
                if operacija=6 then ponovi:=ponoviTZ else ponovi:=ponoviPO; {glede na to, ali je operacija tipicno zaporedje,
                                                                            se nastavi stevilo ponovitev}
                cas1:=cas;
                for n:=1 to ponovi do
                  case operacija of
                    0: if iterMeri then begin {kreiranje}
                      mn1^.mnDest;
                      mn1^.naredi;
                    end;
                    1: begin {dodajanje stevil od 1 do maxSt v mn1, mn2, mn3}
                      zacSproti:=new (kVsTest, vsKons);
                      if n>2*maxSt then begin
                        kVsTest (zacSproti)^.st:=n mod maxSt;
                        if not mn1^.dodaj (zacSproti, true, iterMeri) then dispose (zacSproti, vsDest);
                      end else if n<=maxSt then begin
                          kVsTest (zacSproti)^.st:=n;
                          if not mn2^.dodaj (zacSproti, true, iterMeri) then dispose (zacSproti, vsDest);
                        end else begin
                          kVsTest (zacSproti)^.st:=n-maxSt;
                          if not mn3^.dodaj (zacSproti, true, iterMeri) then dispose (zacSproti, vsDest);
                        end;
                    end;
                    2: if iterMeri then begin {brisanje stevil od 1 do maxSt (vseh enekokrat) iz mn3}
                      kVsTest (zacEnkrat)^.st:=round (n*maxSt/ponovi);
                      mn3^.brisi (zacEnkrat);
                    end;
                    3: begin {preverjanje pripadnosti stevil od 1 do maxSt v mn1}
                      kVsTest (zacEnkrat)^.st:=n mod maxSt;
                      mn1^.pripada (zacEnkrat, iterMeri);
                    end;
                    4: if n mod 2=0 then mn3^.unija (mn1, mn2, iterMeri) else {unija mn1 in mn2 v mn3 ali mn1 in mn2 v mn2}
                          mn2^.unija (mn1, mn2, iterMeri);
                    5: if n mod 2=0 then mn3^.presek (mn1, mn2, iterMeri) else {presek mn1 in mn2 v mn3 ali mn1 in mn2 v mn2}
                          mn2^.presek (mn1, mn2, iterMeri);
                    6: begin {operacija tipicnega zaporedja}
                      case trenutni^.operacija of
                        kreiranje: case n mod 3 of {kreiranje mnTZ1, mnTZ2 ali mnTZ3}
                          0: begin
                            mnTZ1^.mnDest;
                            mnTZ1^.naredi;
                          end;
                          1: begin
                            mnTZ2^.mnDest;
                            mnTZ2^.naredi;
                          end;
                          2: begin
                            mnTZ3^.mnDest;
                            mnTZ3^.naredi;
                          end;
                        end;
                        dodajanje: begin {dodajanje v mnTZ1, mnTZ2 ali mnTZ3}
                          zacSproti:=new (kVsTest, vsKons);
                          kVsTest (zacSproti)^.st:=trenutni^.vrednost;
                          case n mod 3 of
                            0: if not mnTZ1^.dodaj (zacSproti, true, iterMeri) then dispose (zacSproti, vsDest);
                            1: if not mnTZ2^.dodaj (zacSproti, true, iterMeri) then dispose (zacSproti, vsDest);
                            2: if not mnTZ3^.dodaj (zacSproti, true, iterMeri) then dispose (zacSproti, vsDest);
                          end;
                        end;
                        brisanje: begin {brisanje iz mnTZ1, mnTZ2 ali mnTZ3}
                          kVsTest (zacEnkrat)^.st:=trenutni^.vrednost;
                          case n mod 3 of
                            0: mnTZ1^.brisi (zacEnkrat);
                            1: mnTZ1^.brisi (zacEnkrat);
                            2: mnTZ3^.brisi (zacEnkrat);
                          end;
                        end;
                        pripadnost: begin {preverjenje pripadnosti v mnTZ1, mnTZ2 ali mnTZ3}
                          kVsTest (zacEnkrat)^.st:=trenutni^.vrednost;
                          case n mod 3 of
                            0: mnTZ1^.pripada (zacEnkrat, iterMeri);
                            1: mnTZ2^.pripada (zacEnkrat, iterMeri);
                            2: mnTZ3^.pripada (zacEnkrat, iterMeri);
                          end;
                        end;
                        unija: if n mod 2=0 then mnTZ3^.unija (mnTZ1, mnTZ2, iterMeri) else  {unija mnTZ1 in mn TZ2 v mnTZ3 ->}
                          mnTZ2^.unija (mnTZ1, mnTZ2, iterMeri);                             {ali mnTZ2}
                        presek: if n mod 2=0 then mnTZ3^.presek (mnTZ1, mnTZ2, iterMeri) else
                          mnTZ2^.presek (mnTZ1, mnTZ2, iterMeri);
                      end;
                      trenutni:=trenutni^.naslednji;
                    end;
                  end;
                cas2:=cas;
                if iterMeri then begin {izpis rezultatov}
                  gotoXY (21+tip*9, 12+operacija*2);
                  write ((cas2-cas1)/ponovi*10000:8:0);
                end else if (operacija<>0) and (operacija<>2) then begin
                    gotoXY (48+tip*9, 12+operacija*2);
                    write ((cas2-cas1)/ponovi*10000:8:0);
                  end;
                iterMeri:=not iterMeri; {pri 2. ponovitvi je rekurzivno, nato se nastavi iterativno, da se konca}
              until iterMeri;
            end;
            dispose (mn1, mnDest); {po koncu vseh operacij se sprosti spomin, ki so ga zasedale mnozice}
            dispose (mn2, mnDest);
            dispose (mn3, mnDest);
            dispose (mnTZ1, mnDest);
            dispose (mnTZ2, mnDest);
            dispose (mnTZ3, mnDest);
          end;
          dispose (zacEnkrat, vsDest);
          while prviTZ<>nil do begin {sprosti se spomin, ki ga je zasedal seznam za tipicno zaporedje}
            trenutni:=prviTZ;
            prviTZ:=prviTZ^.naslednji;
            dispose (trenutni);
          end;
        end;
        3: stanje:=konec;
      end;
      1: case polozaj.x of
        0: okence (32, 4, 7, ponoviPO, true); {nastavitev stevila ponovitev posameznih operacij}
        1: okence (62, 4, 7, ponoviTZ, true); {nastavitev stevila ponovitev operacij v tipicnem zaporedju}
      end;
      2: case polozaj.x of {nastavitve verjetnosti za posamezne operacij v tipicnem zaporedju}
        0: okence (12, 5, 2, verKreir, true);
        1: okence (26, 5, 2, verDodaj, true);
        2: okence (39, 5, 2, verBris, true);
        3: okence (54, 5, 2, verPripad, true);
        4: okence (64, 5, 2, verUnija, true);
        5: okence (75, 5, 2, verPresek, true);
      end;
    end;
  end;
  case polozaj.y of {prilagajanje vodoravnega polozaja glede na stevilo izbir v vrsti}
    0: if polozaj.x>3 then polozaj.x:=3;
    1: if polozaj.x>0 then polozaj.x:=1;
    2: if polozaj.x>5 then polozaj.x:=5;
  end;
  if (polozaj.y=0) and (polozaj.x=0) then textBackground (red) else textBackground (cyan); {izpis izbir}
  gotoXY (2, 3);
  write ('Interaktivno delo');
  if (polozaj.y=0) and (polozaj.x=1) then textBackground (red) else textBackground (cyan);
  textColor (yellow);
  gotoXY (21, 3);
  write ('Merjenje casa');
  textColor (black);
  if (polozaj.y=0) and (polozaj.x=2) then textBackground (red) else textBackground (cyan);
  gotoXY (38, 3);
  write ('Izvedi');
  if (polozaj.y=0) and (polozaj.x=3) then textBackground (red) else textBackground (cyan);
  gotoXY (48, 3);
  write ('Izhod');
  if (polozaj.y=1) and (polozaj.x=0) then textBackground (red) else textBackground (cyan);
  gotoXY (12, 4);
  write ('posamezne operacije');
  if (polozaj.y=1) and (polozaj.x=1) then textBackground (red) else textBackground (cyan);
  gotoXY (41, 4);
  write ('v tipicnem zaporedju');
  if (polozaj.y=2) and (polozaj.x=0) then textBackground (red) else textBackground (cyan);
  gotoXY (2, 5);
  write ('Kreiranje');
  if (polozaj.y=2) and (polozaj.x=1) then textBackground (red) else textBackground (cyan);
  gotoXY (16, 5);
  write ('Dodajanje');
  if (polozaj.y=2) and (polozaj.x=2) then textBackground (red) else textBackground (cyan);
  gotoXY (30, 5);
  write ('Brisanje');
  if (polozaj.y=2) and (polozaj.x=3) then textBackground (red) else textBackground (cyan);
  gotoXY (43, 5);
  write ('Pripadnost');
  if (polozaj.y=2) and (polozaj.x=4) then textBackground (red) else textBackground (cyan);
  gotoXY (58, 5);
  write ('Unija');
  if (polozaj.y=2) and (polozaj.x=5) then textBackground (red) else textBackground (cyan);
  gotoXY (68, 5);
  write ('Presek');
end;

begin
  verKreir:=0; {nastavitev zacetnih vrednosti spremenljivk}
  verDodaj:=30;
  verBris:=20;
  verPripad:=40;
  verUnija:=5;
  verPresek:=5;
  ponoviPO:=3000;
  ponoviTZ:=3000;
  stanje:=zacInterakt;
  repeat
    znak:=#0;
    case stanje of {glede na stanje, v keterem se program, se izvedejo ustrezne procedure in se prebere pritisnjena tipka}
      zacInterakt: begin
        pZacInterakt;
        pVmesInterakt;
        stanje:=vmesInterakt;
      end;
      vmesInterakt: begin
        znak:=readKey;
        pVmesInterakt;
      end;
      zacMerjenje: begin
        pZacMerjenje (true);
        pVmesMerjenje;
        stanje:=vmesMerjenje;
      end;
      vmesMerjenje: begin
        znak:=readKey;
        pVmesMerjenje;
      end;
    end;
  until stanje=konec;
  for n1:=0 to maxMn do if testneMn [n1]<>nil then dispose (testneMn [n1], mnDest); {sprosti se spomin, ki so ga zasedale
                                                                                    mnozice v delu za interaktivno delo}
  textBackground (black);
  textColor (lightGray);
  clrscr;
end.